//+------------------------------------------------------------------+
//|                                                  Small Hours.mq4 |
//|                                      Copyright  2011, Ido Kasse |
//|              http://www.forexfactory.com/showthread.php?t=280540 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Ido Kasse"
#property link      "http://www.forexfactory.com/showthread.php?t=280540"

extern int corner=1;
extern int y=50;
extern string slevel = "Show Entry, SL and TP2 levels";
extern bool showlevels = true;
extern string lecolor = "Textcolor";
extern color lcolor = Silver;
extern string dbox = "Draw box around the 5 bars range";
extern bool box = true;
extern string multitext = "Enable Multilight (4 pairs)?";
extern bool multi = true;
extern string val1text = "First pair";
extern string val1 = "EURUSD";
extern string val2text = "Second pair";
extern string val2 = "GBPUSD";
extern string val3text = "Third pair";
extern string val3 = "USDJPY";
extern string val4text = "Fourth pair";
extern string val4 = "USDCHF";

double atrvalue, atrvalue2, atrvalue3, atrvalue4, atrcalc, tp1;
double hhll5, hhll52, hhll53, hhll54, hhll5calc;
double hh5, hh52, hh53, hh54, ll5, ll52, ll53, ll54;
double setuphigh, setuphigh2, setuphigh3, setuphigh4, setuplow, setuplow2, setuplow3, setuplow4;
double setupclose, setupclose2, setupclose3, setupclose4;
double sma20, sma40, sma202, sma402, sma203, sma403, sma204, sma404;

//++++ These are adjusted for 5 digit brokers.
double  pips2points,    // slippage  3 pips    3=points    30=points
        pips2dbl;       // Stoploss 15 pips    0.0015      0.00150
int     Digits.pips;    // DoubleToStr(dbl/pips2dbl, Digits.pips)
 
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   ObjectCreate("rule1v1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule1v1", OBJPROP_CORNER, corner);
   ObjectSet("rule1v1", OBJPROP_XDISTANCE, 25);
   ObjectSet("rule1v1", OBJPROP_YDISTANCE, y); 
   ObjectSetText("rule1v1", "O", 15, "Arial Bold", lcolor);   

   ObjectCreate("rule2v1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule2v1", OBJPROP_CORNER, corner);
   ObjectSet("rule2v1", OBJPROP_XDISTANCE, 25);
   ObjectSet("rule2v1", OBJPROP_YDISTANCE, y+20);
   ObjectSetText("rule2v1", "O", 15, "Arial Bold", lcolor);
   
   ObjectCreate("rule3v1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule3v1", OBJPROP_CORNER, corner);
   ObjectSet("rule3v1", OBJPROP_XDISTANCE, 25);
   ObjectSet("rule3v1", OBJPROP_YDISTANCE, y+40);
   ObjectSetText("rule3v1", "O", 15, "Arial Bold", lcolor);

   if (multi==true)
   {
   ObjectCreate("pairs", OBJ_LABEL, 0, 0, 0);
   ObjectSet("pairs", OBJPROP_CORNER, corner);
   ObjectSet("pairs", OBJPROP_XDISTANCE, 15);
   ObjectSet("pairs", OBJPROP_YDISTANCE, y-20); 
   ObjectSetText("pairs", ""+val4+"|"+val3+"|"+val2+"|"+val1, 8, "Arial Bold", lcolor);
   
   ObjectCreate("rule1v2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule1v2", OBJPROP_CORNER, corner);
   ObjectSet("rule1v2", OBJPROP_XDISTANCE, 70);
   ObjectSet("rule1v2", OBJPROP_YDISTANCE, y); 
   ObjectSetText("rule1v2", "O", 15, "Arial Bold", lcolor);   

   ObjectCreate("rule2v2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule2v2", OBJPROP_CORNER, corner);
   ObjectSet("rule2v2", OBJPROP_XDISTANCE, 70);
   ObjectSet("rule2v2", OBJPROP_YDISTANCE, y+20);
   ObjectSetText("rule2v2", "O", 15, "Arial Bold", lcolor);
   
   ObjectCreate("rule3v2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule3v2", OBJPROP_CORNER, corner);
   ObjectSet("rule3v2", OBJPROP_XDISTANCE, 70);
   ObjectSet("rule3v2", OBJPROP_YDISTANCE, y+40);
   ObjectSetText("rule3v2", "O", 15, "Arial Bold", lcolor);

   ObjectCreate("rule1v3", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule1v3", OBJPROP_CORNER, corner);
   ObjectSet("rule1v3", OBJPROP_XDISTANCE, 115);
   ObjectSet("rule1v3", OBJPROP_YDISTANCE, y); 
   ObjectSetText("rule1v3", "O", 15, "Arial Bold", lcolor);   

   ObjectCreate("rule2v3", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule2v3", OBJPROP_CORNER, corner);
   ObjectSet("rule2v3", OBJPROP_XDISTANCE, 115);
   ObjectSet("rule2v3", OBJPROP_YDISTANCE, y+20);
   ObjectSetText("rule2v3", "O", 15, "Arial Bold", lcolor);
   
   ObjectCreate("rule3v3", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule3v3", OBJPROP_CORNER, corner);
   ObjectSet("rule3v3", OBJPROP_XDISTANCE, 115);
   ObjectSet("rule3v3", OBJPROP_YDISTANCE, y+40);
   ObjectSetText("rule3v3", "O", 15, "Arial Bold", lcolor);

   ObjectCreate("rule1v4", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule1v4", OBJPROP_CORNER, corner);
   ObjectSet("rule1v4", OBJPROP_XDISTANCE, 160);
   ObjectSet("rule1v4", OBJPROP_YDISTANCE, y); 
   ObjectSetText("rule1v4", "O", 15, "Arial Bold", lcolor);   

   ObjectCreate("rule2v4", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule2v4", OBJPROP_CORNER, corner);
   ObjectSet("rule2v4", OBJPROP_XDISTANCE, 160);
   ObjectSet("rule2v4", OBJPROP_YDISTANCE, y+20);
   ObjectSetText("rule2v4", "O", 15, "Arial Bold", lcolor);
   
   ObjectCreate("rule3v4", OBJ_LABEL, 0, 0, 0);
   ObjectSet("rule3v4", OBJPROP_CORNER, corner);
   ObjectSet("rule3v4", OBJPROP_XDISTANCE, 160	);
   ObjectSet("rule3v4", OBJPROP_YDISTANCE, y+40);
   ObjectSetText("rule3v4", "O", 15, "Arial Bold", lcolor);
   }

   if (showlevels==true)
   {
   ObjectCreate("stats1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("stats1", OBJPROP_CORNER, corner);
   ObjectSet("stats1", OBJPROP_XDISTANCE, 15);
   ObjectSet("stats1", OBJPROP_YDISTANCE, y+80);

   ObjectCreate("stats2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("stats2", OBJPROP_CORNER, corner);
   ObjectSet("stats2", OBJPROP_XDISTANCE, 15);
   ObjectSet("stats2", OBJPROP_YDISTANCE, y+100);

   ObjectCreate("label", OBJ_LABEL, 0, 0, 0);
   ObjectSet("label", OBJPROP_CORNER, corner);
   ObjectSet("label", OBJPROP_XDISTANCE, 15);
   ObjectSet("label", OBJPROP_YDISTANCE, y+140);
   ObjectSetText("label", "BUY / SELL", 13, "Arial Bold", lcolor);

   ObjectCreate("entry", OBJ_LABEL, 0, 0, 0);
   ObjectSet("entry", OBJPROP_CORNER, corner);
   ObjectSet("entry", OBJPROP_XDISTANCE, 15);
   ObjectSet("entry", OBJPROP_YDISTANCE, y+160);

   ObjectCreate("tp1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("tp1", OBJPROP_CORNER, corner);
   ObjectSet("tp1", OBJPROP_XDISTANCE, 15);
   ObjectSet("tp1", OBJPROP_YDISTANCE, y+180);

   ObjectCreate("tp2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("tp2", OBJPROP_CORNER, corner);
   ObjectSet("tp2", OBJPROP_XDISTANCE, 15);
   ObjectSet("tp2", OBJPROP_YDISTANCE, y+200);

   ObjectCreate("sl", OBJ_LABEL, 0, 0, 0);
   ObjectSet("sl", OBJPROP_CORNER, corner);
   ObjectSet("sl", OBJPROP_XDISTANCE, 15);
   ObjectSet("sl", OBJPROP_YDISTANCE, y+220);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("rule1v1");
   ObjectDelete("rule2v1");
   ObjectDelete("rule3v1");
   if (multi==true)
   {
    ObjectDelete("rule1v2");
    ObjectDelete("rule2v2");
    ObjectDelete("rule3v2");
    ObjectDelete("rule1v3");
    ObjectDelete("rule2v3");
    ObjectDelete("rule3v3");
    ObjectDelete("rule1v4");
    ObjectDelete("rule2v4");
    ObjectDelete("rule3v4");
    ObjectDelete("pairs");
   }
   if (box==true) ObjectDelete("box");
   if (showlevels==true)
   {
    ObjectDelete("stats1");
    ObjectDelete("stats2");
    ObjectDelete("label");
    ObjectDelete("entry");
    ObjectDelete("tp1");
    ObjectDelete("tp2");
    ObjectDelete("sl");
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   if (Digits == 5 || Digits == 3)
   {    // Adjust for five (5) digit brokers.
               pips2dbl    = Point*10; pips2points = 10;   Digits.pips = 1;
   } else {    pips2dbl    = Point;    pips2points =  1;   Digits.pips = 0; }

   ObjectSetText("rule1v1", CharToStr(129), 15, "Wingdings", lcolor);
   ObjectSetText("rule2v1", CharToStr(130), 15, "Wingdings", lcolor);
   ObjectSetText("rule3v1", CharToStr(131), 15, "Wingdings", lcolor);

   if (multi==true)
   {
    ObjectSetText("rule1v2", CharToStr(129), 15, "Wingdings", lcolor);
    ObjectSetText("rule2v2", CharToStr(130), 15, "Wingdings", lcolor);
    ObjectSetText("rule3v2", CharToStr(131), 15, "Wingdings", lcolor);
    ObjectSetText("rule1v3", CharToStr(129), 15, "Wingdings", lcolor);
    ObjectSetText("rule2v3", CharToStr(130), 15, "Wingdings", lcolor);
    ObjectSetText("rule3v3", CharToStr(131), 15, "Wingdings", lcolor);
    ObjectSetText("rule1v4", CharToStr(129), 15, "Wingdings", lcolor);
    ObjectSetText("rule2v4", CharToStr(130), 15, "Wingdings", lcolor);
    ObjectSetText("rule3v4", CharToStr(131), 15, "Wingdings", lcolor);
   }

   if (showlevels==true)
   {
    ObjectSetText("stats1", "ATR / HH5-LL5 Range: "+DoubleToStr(atrcalc,1)+" / "+DoubleToStr(hhll5,1), 9, "Arial Bold", lcolor);
    ObjectSetText("stats2", "Highest / Lowest: "+DoubleToStr(hh5,Digits)+" / "+DoubleToStr(ll5,Digits), 9, "Arial Bold", lcolor);
    ObjectSetText("entry", "Entry: "+DoubleToStr(hh5,Digits)+" / "+DoubleToStr(ll5,Digits), 9, "Arial Bold", lcolor);
    ObjectSetText("tp1", "TP1: "+DoubleToStr(Ask+tp1*pips2dbl,Digits)+" / "+DoubleToStr(Bid-tp1*pips2dbl,Digits), 9, "Arial Bold", Green);
    ObjectSetText("tp2", "TP2: "+DoubleToStr(Ask+atrcalc*pips2dbl,Digits)+" / "+DoubleToStr(Bid-atrcalc*pips2dbl,Digits), 9, "Arial Bold", Lime);
    ObjectSetText("sl", "SL: "+DoubleToStr(ll5,Digits)+" / "+DoubleToStr(hh5,Digits), 9, "Arial Bold", Red);
   }
  
   atrvalue=iATR(val1,0,20,0)*10000;
   atrcalc=atrvalue*1.5;
   tp1=atrvalue*0.75;
   hh5=High[iHighest(val1,0,MODE_HIGH,5,1)];
   ll5=Low[iLowest(val1,0,MODE_LOW,5,1)];
   hhll5=(hh5-ll5)*10000;
   if (multi==true)
   {
    atrvalue2=iATR(val2,0,20,0)*10000;
    atrvalue3=iATR(val3,0,20,0)*10000;
    atrvalue4=iATR(val4,0,20,0)*10000;
    ll52=Low[iLowest(val2,0,MODE_LOW,5,1)];
    ll53=Low[iLowest(val3,0,MODE_LOW,5,1)];
    ll54=Low[iLowest(val4,0,MODE_LOW,5,1)];
    hh52=High[iHighest(val2,0,MODE_HIGH,5,1)];
    hh53=High[iHighest(val3,0,MODE_HIGH,5,1)];
    hh54=High[iHighest(val4,0,MODE_HIGH,5,1)];
    hhll52=(hh52-ll52)*10000;
    hhll53=(hh53-ll53)*10000;
    hhll54=(hh54-ll54)*10000;
   }   

   if (NormalizeDouble(hhll5,0)<NormalizeDouble((atrvalue*1.5),0)) ObjectSetText("rule1v1", CharToStr(129), 15, "Wingdings", Orange);
   
   if (multi==true)
   {
    if (NormalizeDouble(hhll52,0)<NormalizeDouble((atrvalue2*1.5),0)) ObjectSetText("rule1v2", CharToStr(129), 15, "Wingdings", Orange);
    if (NormalizeDouble(hhll53,0)<NormalizeDouble((atrvalue3*1.5),0)) ObjectSetText("rule1v3", CharToStr(129), 15, "Wingdings", Orange);
    if (NormalizeDouble(hhll54,0)<NormalizeDouble((atrvalue4*1.5),0)) ObjectSetText("rule1v4", CharToStr(129), 15, "Wingdings", Orange);
   }

   setupclose=iClose(val1,0,1);
   sma20=iMA(val1,0,20,0,MODE_SMA,PRICE_CLOSE,1);
   sma40=iMA(val1,0,40,0,MODE_SMA,PRICE_CLOSE,1);
   if (multi==true)
   {
    setupclose2=iClose(val2,0,1);
    sma202=iMA(val2,0,20,0,MODE_SMA,PRICE_CLOSE,1);
    sma402=iMA(val2,0,40,0,MODE_SMA,PRICE_CLOSE,1);
    setupclose3=iClose(val3,0,1);
    sma203=iMA(val3,0,20,0,MODE_SMA,PRICE_CLOSE,1);
    sma403=iMA(val3,0,40,0,MODE_SMA,PRICE_CLOSE,1);
    setupclose4=iClose(val4,0,1);
    sma204=iMA(val4,0,20,0,MODE_SMA,PRICE_CLOSE,1);
    sma404=iMA(val4,0,40,0,MODE_SMA,PRICE_CLOSE,1);
   }
   
   if (setupclose>sma20||setupclose>sma40) ObjectSetText("rule3v1", CharToStr(131), 15, "Wingdings", Lime);
   if (setupclose<sma20||setupclose<sma40) ObjectSetText("rule3v1", CharToStr(131), 15, "Wingdings", Red);
   if (multi==true)
   {
    if (setupclose2>sma202||setupclose2>sma402) ObjectSetText("rule3v2", CharToStr(131), 15, "Wingdings", Lime);
    if (setupclose2<sma202||setupclose2<sma402) ObjectSetText("rule3v2", CharToStr(131), 15, "Wingdings", Red);
    if (setupclose3>sma203||setupclose3>sma403) ObjectSetText("rule3v3", CharToStr(131), 15, "Wingdings", Lime);
    if (setupclose3<sma203||setupclose3<sma403) ObjectSetText("rule3v3", CharToStr(131), 15, "Wingdings", Red);
    if (setupclose4>sma204||setupclose4>sma404) ObjectSetText("rule3v4", CharToStr(131), 15, "Wingdings", Lime);
    if (setupclose4<sma204||setupclose4<sma404) ObjectSetText("rule3v4", CharToStr(131), 15, "Wingdings", Red);
   }
    
   setuphigh=iHigh(val1,0,1);
   setuplow=iLow(val1,0,1);
   if (multi==true)
   {
    setuphigh2=iHigh(val2,0,1);
    setuplow2=iLow(val2,0,1);
    setuphigh3=iHigh(val3,0,1);
    setuplow3=iLow(val3,0,1);
    setuphigh4=iHigh(val4,0,1);
    setuplow4=iLow(val4,0,1);
   }
   if (setuphigh<hh5) ObjectSetText("rule2v1", CharToStr(130), 15, "Wingdings", Lime);
   if (setuplow>ll5) ObjectSetText("rule2v1", CharToStr(130), 15, "Wingdings", Red);
   if (multi==true)
   {
    if (setuphigh2<hh52) ObjectSetText("rule2v2", CharToStr(130), 15, "Wingdings", Lime);
    if (setuplow2>ll52) ObjectSetText("rule2v2", CharToStr(130), 15, "Wingdings", Red);
    if (setuphigh3<hh53) ObjectSetText("rule2v3", CharToStr(130), 15, "Wingdings", Lime);
    if (setuplow3>ll53) ObjectSetText("rule2v3", CharToStr(130), 15, "Wingdings", Red);
    if (setuphigh4<hh54) ObjectSetText("rule2v4", CharToStr(130), 15, "Wingdings", Lime);
    if (setuplow4>ll54) ObjectSetText("rule2v4", CharToStr(130), 15, "Wingdings", Red);
   }

   if(box==true)
   {
    ObjectDelete("box");
    ObjectCreate("box", OBJ_RECTANGLE, 0, Time[5], High[iHighest(val1,0,MODE_HIGH,5,1)], Time[1], Low[iLowest(val1,0,MODE_LOW,5,1)]);
    ObjectSet("box", OBJPROP_STYLE, STYLE_DASHDOTDOT);
    ObjectSet("box", OBJPROP_COLOR, MidnightBlue);
    ObjectSet("box", OBJPROP_WIDTH, 1);
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+